Форум программистов, компьютерный форум, киберфорум
Наши страницы

Lisp

Войти
Регистрация
Восстановить пароль
 
Рейтинг: Рейтинг темы: голосов - 15, средняя оценка - 4.80
Uxxzz
9 / 9 / 0
Регистрация: 05.04.2011
Сообщений: 67
#1

неверный тип аргумента:2D/3D точка :nil - Lisp

26.01.2012, 13:33. Просмотров 2162. Ответов 0
Метки нет (Все метки)

Здравствуйте, помогите пожалуйста с прогой..
вот мое задание: Извлечение данных о примитивах чертежа. Путём доступа к графической базе данных чертежа получить информацию (имя слоя, номер цвета, тип линии, координаты вершин, начальной и конечной точки) о примитивах: линиях, полилиниях, сплайнах. Записать полученную информацию в заданный пользователем файл. Диалоговое окно должно иметь возможность выбора типов примитивов, и отображать их количество в соответствии с видом диалогового окна на рисунке.

вот мой код
Lisp
1
2
3
4
5
6
7
8
9
10
11
12
13
14
15
16
17
18
19
20
21
22
23
24
25
26
27
28
29
30
31
32
33
34
35
36
37
38
39
40
41
42
43
44
45
46
47
48
49
50
51
52
53
54
55
56
57
58
59
60
61
62
63
64
65
66
67
68
69
70
71
72
73
74
75
76
77
78
79
80
81
82
83
84
85
86
87
88
89
90
91
92
93
94
95
96
97
98
99
100
101
102
103
104
105
106
107
108
109
110
111
112
113
114
115
116
117
118
119
120
121
122
123
124
125
126
127
128
129
130
131
132
133
134
135
136
137
138
139
140
141
142
143
144
145
146
147
148
149
150
151
152
153
154
155
156
157
158
159
160
161
162
163
164
165
166
167
168
169
170
171
172
173
174
175
176
177
178
179
180
181
182
183
184
185
186
187
188
189
190
191
192
193
194
195
196
197
198
199
200
201
202
203
204
205
206
207
208
209
210
211
212
213
214
215
216
217
218
219
220
221
222
223
224
225
226
227
228
229
230
231
232
233
234
235
236
237
238
239
240
241
242
243
244
245
246
247
248
249
250
251
252
253
254
255
256
257
258
259
260
261
262
263
264
265
(defun sav()
(setq f (open text "W"))
 
 
(if (= (atoi veb_line) 1)
 (  progn
(setq sdel (ssget "X" '((0 . "LINE"))))
(if (/= sdel nil)
( progn
(setq i 0)
(while (< i (sslength sdel))
(setq q (entget (ssname sdel i)))
(setq lin (cdr (assoc 62 q)))
(setq f (open text "A"))
(write-line "" f)
  (princ "Line_" f)
  (princ i f)
  (princ "; " f)
  (princ "color=" f)
  (princ lin f)
  (princ "; " f)
(setq lin (cdr (assoc 10 q)))
  (princ "begin_point=" f)
  (princ lin f)
  (princ "; " f)
(setq lin (cdr (assoc 11 q)))
  (princ "end_point=" f)
  (princ lin f)
  (princ "; " f)
(setq lin (cdr (assoc 8 q))) 
  (princ "Layer_name=" f)
  (princ lin f)
  (princ "; " f)
 (setq lin (cdr (assoc 6 q))) 
  (princ "Type_line=" f)
  (princ lin f)
  (princ "." f)
  
(write-line "" f)  
(close f)  
(setq i(+ i 1))
(setq f (open text "A"))
))
)
 )
 )
 
 
(if (= (atoi veb_polyline) 1)
(  progn
(setq sdell (ssget "X" '((0 . "LWPOLYLINE"))))
(if (/= sdell nil)
( progn
(setq j 0)
(while (< j (sslength sdell)) 
(setq r (entget (ssname sdell j)))
(setq pol (cdr (assoc 62 r)))
(setq f (open text "A"))
(write-line "" f)
  (princ "Polyline_" f)
  (princ j f)
  (princ "; " f)
  (princ "color=" f)
  (princ pol f)
  (princ "; " f)  
(princ "Coordinates=" f)  
(foreach n r (if (= (car n) 10)
                     (progn
                     (setq qxc (cdr n))
                     (princ qxc f)
                     (princ "; " f)
                     )
                     )
               
)
(setq a 0)
 
(foreach n r (if (= (car n) 42)
                    (progn
                    (setq a (+ a 1))
                    (if (/= (cdr n) 0)
                        (progn
                        (setq aa a)
                        (setq zas (cdr n))
                        (setq bubl zas)
                        (setq aaa (+ aa 1))
                        (setq b 0)
                                    (foreach n r (if (= (car n) 10)
                        (progn
                        (setq b (+ b 1))
                        (if (= b aa)
                        (setq pt1 (cdr n))
                        )
                        (if (= b aaa)
                        (setq pt2 (cdr n))
                        )
(if (and (/= bubl nil) (/= bubl 0) )
 (progn
(setq   dst (distance pt1 pt2)
    rad (+ (* (/ dst 2.0) bubl) (/ (- (* (/ dst 2.0) (/ dst 2.0))
        (* (/ (* dst bubl) 2.0) (/ (* dst bubl) 2.0))) (* dst bubl)))
    cnt (polar
        (polar pt1 (angle pt1 pt2) (/ dst 2.0))
        (- (angle pt1 pt2) (/ pi 2.0))
        (- (* (/ dst 2.0) bubl) rad))
)
(setq pt (strcat "\n" "\t" " Radius=" (rtos (abs rad) 2 3) "; " "Centr=(" (rtos (nth 0 cnt) 2 3) " " (rtos (nth 1 cnt) 2 3) "); "))
(princ pt f)
(setq bubl 0)
 
 
 )
)
                        )
                        )
                                        )
                        )
                    )
                    )
            )
)
;(setq b 0)
; (foreach n r (if (= (car n) 10)
                ; (progn
                  ; (setq b (+ b 1))
                  ; (if (= b aa)
                   ; (setq pt1 (cdr n))
                  ; )
                  ; (if (= b aaa)
                   ; (setq pt2 (cdr n))
                  ; )
                ; )
              ; )
; )
 
; (if (/= bubl 0)
 ; (progn
; (setq     dst (distance pt1 pt2)
    ; rad   (+ (* (/ dst 2.0) bubl) (/ (- (* (/ dst 2.0) (/ dst 2.0))
        ; (* (/ (* dst bubl) 2.0) (/ (* dst bubl) 2.0))) (* dst bubl)))
    ; cnt   (polar
        ; (polar pt1 (angle pt1 pt2) (/ dst 2.0))
        ; (- (angle pt1 pt2) (/ pi 2.0))
        ; (- (* (/ dst 2.0) bubl) rad))
; )
; (setq pt (strcat "\n" "\t" " Radius=" (rtos rad 2 3) "; " "Centr=(" (rtos (nth 0 cnt) 2 3) " " (rtos (nth 1 cnt) 2 3) "); "))
; (princ pt f)
 
 ; )
; )
(setq pol (cdr (assoc 8 r))) 
  (princ "Layer_name=" f)
  (princ pol f)
  (princ "; " f)
 (setq pol (cdr (assoc 6 r))) 
  (princ "Type_line=" f)
  (princ pol f)
  (princ "." f)
  
(write-line "" f)  
(close f)  
(setq j(+ j 1))
(setq f (open text "A"))
)
)
)
 )
 )
 
 
(if (= (atoi veb_spline) 1)
(  progn
(setq sdelll (ssget "X" '((0 . "SPLINE"))))
(if (/= sdelll nil)
( progn
(setq k 0)
(while (< k (sslength sdelll)) 
(setq nabor_spline (entget (ssname sdelll k)))
(setq pol (cdr (assoc 62 nabor_spline)))
(setq f (open text "A"))
(write-line "" f)
  (princ "Spline_" f)
  (princ k f)
  (princ "; " f)
  (princ "color=" f)
  (princ pol f)
  (princ "; " f)
  (princ "Coordinates=" f)
(foreach n nabor_spline  (if (= (car n) 10)
                      (progn
                     (setq qwee (cdr n))
                     (princ qwee f)
                     (princ "; " f)
                       )
                     )              
)
(setq pol (cdr (assoc 8 nabor_spline))) 
  (princ "Layer_name=" f)
  (princ pol f)
  (princ "; " f)
 (setq pol (cdr (assoc 6 nabor_spline))) 
  (princ "Type_line=" f)
  (princ pol f)
  (princ "." f)
  
(write-line "" f)  
(close f)  
(setq k(+ k 1))
(setq f (open text "A"))
)
 )
 )
 (setq f (open text "A"))
 (close f)
 ))
)
 
 
 
 
 
 
 
(defun run()
  (if (not (new_dialog "MY" dcl_id)) (exit))
 
(setq sdel (ssget "X" '((0 . "LINE"))))
   (if (/= sdel nil)
  (setq num_line (itoa (sslength sdel)))
    )
  (setq sdell (ssget "X" '((0 . "LWPOLYLINE"))))
   (if (/= sdell nil) 
  (setq num_polyline (itoa (sslength sdell)))
    )
  (setq sdelll (ssget "X" '((0 . "SPLINE"))))
   (if (/= sdelll nil)
  (setq num_spline (itoa (sslength sdelll)))
    )
 
(set_tile "num_spline" num_spline )
(set_tile "num_polyline" num_polyline )
(set_tile "num_line" num_line )
(set_tile "text" text )
 
 
(action_tile "text" "(setq text $value)")
(action_tile "tg_spline" "(setq veb_spline  $value)" )
(action_tile "tg_polyline" "(setq veb_polyline $value)")
(action_tile "tg_line" "(setq veb_line $value)")
(action_tile "bt_Accept" "(done_dialog 1)")
(action_tile "bt_Cancel" "(setq w_n 0)")
 
(action_tile "bt_Accept" "(done_dialog 1)")
(action_tile "bt_Cancel" "(setq w_n 0)")
 
(setq w_n (start_dialog))
  (if (= w_n 1) (sav))
)
 
(defun c:MY ()
  (setq w_n 2  text "D:\\text.txt" num_polyline "0" num_line "0" num_spline "0" i 0 j 0 k 0 veb_polyline "0" veb_spline "0" veb_line "0") 
  (setq dcl_id (load_dialog "MY.dcl"))
  (while (> w_n 0) (run))
  (unload_dialog dcl_id)
)
диалоговое окно:
Lisp
1
2
3
4
5
6
7
8
9
10
11
12
13
14
15
16
17
18
19
20
21
22
23
24
25
26
27
28
29
30
31
32
33
34
35
36
37
38
39
40
41
42
43
44
45
46
47
48
49
50
51
52
53
54
55
56
57
58
59
60
61
62
63
64
65
66
67
68
69
70
71
72
73
74
75
76
77
78
79
80
81
82
83
84
85
 MY : dialog {
label = "Извлечение данных о примитивах";
    fixed_width = true;
    fixed_height = true;
    :edit_box {
         label = "Имя файла";
         fixed_width = true;
         edit_width=15;
         alignment=left;
         key="text";}
    :row {
         :column {
             label = "Выбор примитивов";
             fixed_width = true;
             height = 6;
             fixed_height = true;
             children_fixed_heigth = true;
             children_fixed_width = true;
             alignment=left;
             :toggle{
                label="Сплайны";
                key="tg_spline";
                            value="0";}
                 :toggle{
                label="Полилинии";
                key="tg_polyline";
                            value="0";}
             :toggle{
                label="Линии";
                key="tg_line";
                value="0";}
            }
         :column {
             label = "Найдено примитивов";
             fixed_width = true;
             height = 6;
             fixed_height = true;
             children_fixed_heigth = true;
             children_fixed_width = true;
             alignment=left;
             :edit_box {
                label = "Сплайны";
                fixed_width = true;
                edit_width=4;
                alignment=right;
                key="num_spline";}
             :edit_box {
                label = "Полилинии";
                fixed_width = true;
                edit_width=4;
                alignment=right;
                key="num_polyline";}
             :edit_box {
                label = "Линии";
                fixed_width = true;
                edit_width=4;
                alignment=right;
                key="num_line";}
                }
        }
    
    :row{label = "";
        fixed_width=true;
        alignment = left;
            :button{
            key="bt_Accept";
            label="Готово";
            is_default=true;
            is_cancel =false;
            is_tab_stop = true;
            fixed_width = true;
            }
 
            :button{                
            key="bt_Cancel";
            label="Отмена";
            is_default=false;  //Не срабатывает, если нажат Enter
            is_cancel=true;    //Срабатывает, если нажат Р или Esc
            is_tab_stop = true;//Фокус переключается между кнопками
            fixed_width = true;//Ширина кнопки - по ширине надписи 
            }
        
    }
 
}
программа работает нормально но вот когда рисуешь полилинию состоящую из дуг, то при попытке извлечь о ней информацию выдает ошибку:неверный тип аргумента:2D/3D точка :nil
что нужно сделать что бы программа заработала нормально???
1
Надоела реклама? Зарегистрируйтесь и она исчезнет полностью.
Similar
Эксперт
41792 / 34177 / 6122
Регистрация: 12.04.2006
Сообщений: 57,940
26.01.2012, 13:33
Я подобрал для вас темы с готовыми решениями и ответами на вопрос неверный тип аргумента:2D/3D точка :nil (Lisp):

Вернуть Т, если значение аргумента - циклическая списочная структура, и NIL, если в значении аргумента нет циклов - Lisp
Помогите сделать функцию вырабатывает значение Т, если значение аргумента - циклическая списочная структура, и значение NIL, если в...

Почему на выходе nil? - Lisp
Хочу сделать ввод в список с клавиатуры до того, как будет введён nil. Подскажите пожалуйста, что я недопонимаю и почему в итоге список...

Всё время NIL - Lisp
Доброго времени! Задача: Моё решение: (defun my-subs (mylist) (cond ((null '(mylist)) nil) ((eq (car '(mylist)) 'x ) ...

Memory Full Break: NIL - Lisp
написал вот такой код: (setq f (list 1 2 3 4 5 6)) (defun F (L1) (cons (cadr L1) (F (cdr L1)))) (print (F f)) а оно мне выдает...

nil в R5RS, оно там есть? - Lisp
(cons 1 nil) Получаем: reference to undefined identifier: nil Разве можно без nil? R5RS из DrRacket Добавлено через 16...

Найти первый отличный от NIL атом в произвольном списке - Lisp
Помогите найти первый отличный от NIL атом в произвольном списке (общей рекурсией) ((() A) B C) –&gt; A Сделал без рекурсии, а вот с...

0
MoreAnswers
Эксперт
37091 / 29110 / 5898
Регистрация: 17.06.2006
Сообщений: 43,301
26.01.2012, 13:33
Привет! Вот еще темы с ответами:

Ниже приведена функция sum, которая позволяет получить сумму элементов списка, не равных NIL - Lisp
Ниже приведена функция sum, которая позволяет получить сумму элементов списка, не равных NIL. К сожалению, эта функция работает не совсем...

Написать функцию, которая выдает в качестве результата предпоследний элемент списка, если он есть, а иначе NIL - Lisp
Написать функцию, которая выдает в качестве результата предпоследний элемент списка, если он есть, а иначе NIL

Определить первый атом в списке, а если такого в списке нет, вывести nil - Lisp
Помогите с написанием функции на lisp. 1. Функция которая определяет первый атом в списке, а если такого в списке нет, выводит нил....

Тип ошибки: ADODB.Recordset (0x800A0BB9) Аргументы имеют неверный тип, выходят за пределы допустимого диапазона или ... - VBA
Народ здравствуй! Проблема не могу добавить запись в базу! Открываю соединение Set Cnxn2 =...


Искать еще темы с ответами

Или воспользуйтесь поиском по форуму:
1
Ответ Создать тему
Опции темы

КиберФорум - форум программистов, компьютерный форум, программирование
Powered by vBulletin® Version 3.8.9
Copyright ©2000 - 2018, vBulletin Solutions, Inc.
Рейтинг@Mail.ru